libstdc++: std::list< _Tp, _Alloc > Class Template Reference

libstdc++

std::list< _Tp, _Alloc > Class Template Reference
Containers » Sequences

`#include <stl_list.h>`

Inheritance diagram for std::list< _Tp, _Alloc >:
[legend]

## Public Types
typedef _Alloc | allocator_type
typedef _Node_traits::_Const_iterator | const_iterator
typedef _Tp_alloc_traits::const_pointer | const_pointer
typedef _Tp_alloc_traits::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef _Node_traits::_Iterator | iterator
typedef _Tp_alloc_traits::pointer | pointer
typedef _Tp_alloc_traits::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef size_t | size_type
typedef _Tp | value_type

## Public Member Functions
| list ()=default
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
| list (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
| list (const allocator_type &__a) noexcept
| list (const list &__x)
| list (const list &__x, const __type_identity_t< allocator_type > &__a)
| list (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
| list (list &&)=default
| list (list &&__x, const __type_identity_t< allocator_type > &__a) noexcept(_Node_alloc_traits::_S_always_equal())
| list (size_type __n, const allocator_type &__a=allocator_type())
| list (size_type __n, const value_type &__value, const allocator_type &__a=allocator_type())
| ~list ()=default
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
void | assign (_InputIterator __first, _InputIterator __last)
void | assign (initializer_list< value_type > __l)
void | assign (size_type __n, const value_type &__val)
const_reference | back () const noexcept
reference | back () noexcept
const_iterator | begin () const noexcept
iterator | begin () noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
iterator | emplace (const_iterator __position, _Args &&... __args)
template<typename... _Args>
reference | emplace_back (_Args &&... __args)
template<typename... _Args>
reference | emplace_front (_Args &&... __args)
bool | empty () const noexcept
const_iterator | end () const noexcept
iterator | end () noexcept
iterator | erase (const_iterator __first, const_iterator __last) noexcept
iterator | erase (const_iterator __position) noexcept
const_reference | front () const noexcept
reference | front () noexcept
allocator_type | get_allocator () const noexcept
iterator | insert (const_iterator __p, initializer_list< value_type > __l)
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
iterator | insert (const_iterator __position, _InputIterator __first, _InputIterator __last)
iterator | insert (const_iterator __position, size_type __n, const value_type &__x)
size_type | max_size () const noexcept
void | merge (list &&__x)
template<typename _StrictWeakOrdering>
void | merge (list &&__x, _StrictWeakOrdering __comp)
void | merge (list &__x)
template<typename _StrictWeakOrdering>
void | merge (list &__x, _StrictWeakOrdering __comp)
list & | operator= (const list &__x)
list & | operator= (initializer_list< value_type > __l)
list & | operator= (list &&__x) noexcept(_Node_alloc_traits::_S_nothrow_move())
void | pop_back () noexcept
void | pop_front () noexcept
void | push_back (const value_type &__x)
void | push_back (value_type &&__x)
void | push_front (const value_type &__x)
void | push_front (value_type &&__x)
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
__remove_return_type | remove (const _Tp &__value)
template<typename _Predicate>
__remove_return_type | remove_if (_Predicate)
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
void | resize (size_type __new_size)
void | resize (size_type __new_size, const value_type &__x)
void | reverse () noexcept
size_type | size () const noexcept
void | sort ()
template<typename _StrictWeakOrdering>
void | sort (_StrictWeakOrdering)
void | splice (const_iterator __position, list &&__x) noexcept
void | splice (const_iterator __position, list &&__x, const_iterator __first, const_iterator __last) noexcept
void | splice (const_iterator __position, list &__x) noexcept
void | splice (const_iterator __position, list &__x, const_iterator __first, const_iterator __last) noexcept
void | swap (list &__x) noexcept
__remove_return_type | unique ()
template<typename _BinaryPredicate>
__remove_return_type | unique (_BinaryPredicate)
iterator | insert (const_iterator __position, const value_type &__x)
iterator | insert (const_iterator __position, value_type &&__x)
void | splice (const_iterator __position, list &&__x, const_iterator __i) noexcept
void | splice (const_iterator __position, list &__x, const_iterator __i) noexcept

## Protected Types
typedef _Node_alloc_traits::pointer | _Node_ptr

## Protected Member Functions
template<typename _InputIterator>
void | _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
template<typename _Integer>
void | _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
void | _M_check_equal_allocators (const list &__x) noexcept
void | _M_clear () noexcept
template<typename... _Args>
_Node_ptr | _M_create_node (_Args &&... __args)
void | _M_dec_size (size_t __n)
void | _M_default_append (size_type __n)
void | _M_default_initialize (size_type __n)
void | _M_destroy_node (_Node_ptr __p)
size_t | _M_distance (const __detail::_List_node_base *__first, const __detail::_List_node_base *__last) const
void | _M_erase (iterator __position) noexcept
void | _M_fill_assign (size_type __n, const value_type &__val)
void | _M_fill_initialize (size_type __n, const value_type &__x)
_Node_alloc_traits::pointer | _M_get_node ()
const _Node_alloc_type & | _M_get_Node_allocator () const noexcept
_Node_alloc_type & | _M_get_Node_allocator () noexcept
size_t | _M_get_size () const
void | _M_inc_size (size_t __n)
void | _M_init () noexcept
template<typename _InputIterator>
void | _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
template<typename _Integer>
void | _M_initialize_dispatch (_Integer __n, _Integer __x, __true_type)
template<typename... _Args>
void | _M_insert (iterator __position, _Args &&... __args)
void | _M_move_assign (list &&__x, false_type)
void | _M_move_assign (list &&__x, true_type) noexcept
void | _M_move_nodes (_List_base &&__x)
size_t | _M_node_count () const
void | _M_put_node (_Node_ptr __p) noexcept
const_iterator | _M_resize_pos (size_type &__new_size) const
void | _M_set_size (size_t __n)
void | _M_transfer (iterator __position, iterator __first, iterator __last)

## Static Protected Member Functions
static size_t | _S_distance (const __detail::_List_node_base *__first, const __detail::_List_node_base *__last)
static size_t | _S_distance (const_iterator __first, const_iterator __last)

## Protected Attributes
_List_impl | _M_impl

## Detailed Description

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
class std::list< _Tp, _Alloc >

A standard container with linear time access to elements, and fixed time insertion/deletion at any point in the sequence.

Template Parameters

  _Tp | Type of element.
  _Alloc | Allocator type, defaults to allocator<_Tp>.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements with the exception of `at` and `operator`[].

This is a doubly linked list. Traversal up and down the list requires linear time, but adding and removing elements (or nodes) is done in constant time, regardless of where the change takes place. Unlike std::vector and std::deque, random-access iterators are not provided, so subscripting ( ``[] ) access is not allowed. For algorithms which only need sequential access, this lack makes no difference.

Also unlike the other standard containers, std::list provides specialized algorithms unique to linked lists, such as splicing, sorting, and in-place reversal.

A couple points on memory allocation for list<Tp>:

First, we never actually allocate a Tp, we allocate List_node<Tp>'s and trust [20.1.5]/4 to DTRT. This is to ensure that after elements from list<X,Alloc1> are spliced into list<X,Alloc2>, destroying the memory of the second list is a valid operation, i.e., Alloc1 giveth and Alloc2 taketh away.

Second, a list conceptually represented as

A <---> B <---> C <---> D

is actually circular; a link exists between A and D. The list class holds (as its only data member) a private list::iterator pointing to D, not to A! To get to the head of the list, we start at the tail and move forward by one. When this member iterator's next/previous pointers refer to itself, the list is empty.

Definition at line 1025 of file stl_list.h.

## Member Typedef Documentation

## ◆ _Node_ptr

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Node_alloc_traits::pointer std::list< _Tp, _Alloc >::_Node_ptr
| protected

Definition at line 1069 of file stl_list.h.

## ◆ allocator_type

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Alloc std::list< _Tp, _Alloc >::allocator_type

Definition at line 1064 of file stl_list.h.

## ◆ const_iterator

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Node_traits::_Const_iterator std::list< _Tp, _Alloc >::const_iterator

Definition at line 1059 of file stl_list.h.

## ◆ const_pointer

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Tp_alloc_traits::const_pointer std::list< _Tp, _Alloc >::const_pointer

Definition at line 1055 of file stl_list.h.

## ◆ const_reference

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Tp_alloc_traits::const_reference std::list< _Tp, _Alloc >::const_reference

Definition at line 1057 of file stl_list.h.

## ◆ const_reverse_iterator

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef std::reverse_iterator<const_iterator> std::list< _Tp, _Alloc >::const_reverse_iterator

Definition at line 1060 of file stl_list.h.

## ◆ difference_type

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef ptrdiff_t std::list< _Tp, _Alloc >::difference_type

Definition at line 1063 of file stl_list.h.

## ◆ iterator

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Node_traits::_Iterator std::list< _Tp, _Alloc >::iterator

Definition at line 1058 of file stl_list.h.

## ◆ pointer

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Tp_alloc_traits::pointer std::list< _Tp, _Alloc >::pointer

Definition at line 1054 of file stl_list.h.

## ◆ reference

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Tp_alloc_traits::reference std::list< _Tp, _Alloc >::reference

Definition at line 1056 of file stl_list.h.

## ◆ reverse_iterator

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef std::reverse_iterator<iterator> std::list< _Tp, _Alloc >::reverse_iterator

Definition at line 1061 of file stl_list.h.

## ◆ size_type

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef size_t std::list< _Tp, _Alloc >::size_type

Definition at line 1062 of file stl_list.h.

## ◆ value_type

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Tp std::list< _Tp, _Alloc >::value_type

Definition at line 1053 of file stl_list.h.

## Constructor & Destructor Documentation

## ◆ list() [1/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( |  | ) |
| default

Creates a list with no elements.

Referenced by erase(), insert(), insert(), insert(), merge(), merge(), operator=(), remove(), remove_if(), unique(), and unique().

## ◆ list() [2/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( | const allocator_type & | __a | ) |
| inlineexplicitnoexcept

Creates a list with no elements.

Parameters

  __a | An allocator object.

Definition at line 1130 of file stl_list.h.

## ◆ list() [3/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( | size_type | __n,
|  | const allocator_type & | __a = allocator_type() )
| inlineexplicit

Creates a list with default constructed elements.

Parameters

  __n | The number of elements to initially create.
  __a | An allocator object.

This constructor fills the list with __n default constructed elements.

Definition at line 1143 of file stl_list.h.

## ◆ list() [4/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( | size_type | __n,
|  | const value_type & | __value,
|  | const allocator_type & | __a = allocator_type() )
| inline

Creates a list with copies of an exemplar element.

Parameters

  __n | The number of elements to initially create.
  __value | An element to copy.
  __a | An allocator object.

This constructor fills the list with __n copies of __value.

Definition at line 1155 of file stl_list.h.

## ◆ list() [5/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( | const list< _Tp, _Alloc > & | __x | ) |
| inline

List copy constructor.

Parameters

  __x | A list of identical element and allocator types.

The newly-created list uses a copy of the allocation object used by __x (unless the allocator traits dictate a different object).

Definition at line 1182 of file stl_list.h.

## ◆ list() [6/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( | list< _Tp, _Alloc > && |  | ) |
| default

List move constructor.

The newly-created list contains the exact contents of the moved instance. The contents of the moved instance are a valid, but unspecified list.

## ◆ list() [7/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds a list from an initializer_list.

Parameters

  __l | An initializer_list of value_type.
  __a | An allocator object.

Create a list consisting of copies of the elements in the initializer_list __l. This is linear in __l.size().

Definition at line 1205 of file stl_list.h.

## ◆ list() [8/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( | const list< _Tp, _Alloc > & | __x,
|  | const __type_identity_t< allocator_type > & | __a )
| inline

Definition at line 1210 of file stl_list.h.

## ◆ list() [9/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::list | ( | list< _Tp, _Alloc > && | __x,
|  | const __type_identity_t< allocator_type > & | __a )
| inlinenoexcept

Definition at line 1230 of file stl_list.h.

## ◆ list() [10/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

std::list< _Tp, _Alloc >::list | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds a list from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __a | An allocator object.

Create a list consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 1250 of file stl_list.h.

## ◆ ~list()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::list< _Tp, _Alloc >::~list | ( |  | ) |
| default

No explicit dtor needed as the _Base dtor takes care of things. The _Base dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

## Member Function Documentation

## ◆ _M_assign_dispatch() [1/2]

template<typename _Tp, typename _Alloc>
template<typename _InputIterator>

void list::_M_assign_dispatch | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | __false_type | )
| protected

Definition at line 303 of file list.tcc.

## ◆ _M_assign_dispatch() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _Integer>

void std::list< _Tp, _Alloc >::_M_assign_dispatch | ( | _Integer | __n,
|  | _Integer | __val,
|  | __true_type | )
| inlineprotected

Definition at line 2438 of file stl_list.h.

## ◆ _M_check_equal_allocators()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::_M_check_equal_allocators | ( | const list< _Tp, _Alloc > & | __x | ) |
| inlineprotectednoexcept

Definition at line 2491 of file stl_list.h.

## ◆ _M_clear()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_clear | ( |  | ) |
| noexceptinherited

Definition at line 66 of file list.tcc.

## ◆ _M_create_node()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename... _Args>

_Node_ptr std::list< _Tp, _Alloc >::_M_create_node | ( | _Args &&... | __args | ) |
| inlineprotected

Parameters

  __args | An instance of user data.

Allocates space for a new node and constructs a copy of __args in it.

Definition at line 1102 of file stl_list.h.

Referenced by emplace(), and insert().

## ◆ _M_dec_size()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_dec_size | ( | size_t | __n | ) |
| inlineprotectedinherited

Definition at line 803 of file stl_list.h.

## ◆ _M_default_append()

template<typename _Tp, typename _Alloc>

void list::_M_default_append | ( | size_type | __n | ) |
| protected

Definition at line 206 of file list.tcc.

## ◆ _M_default_initialize()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::_M_default_initialize | ( | size_type | __n | ) |
| inlineprotected

Definition at line 2419 of file stl_list.h.

## ◆ _M_destroy_node()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_destroy_node | ( | _Node_ptr | __p | ) |
| inlineprotectedinherited

Definition at line 839 of file stl_list.h.

## ◆ _M_distance()

template<typename _Tp, typename _Alloc>

size_t std::_List_base< _Tp, _Alloc >::_M_distance | ( | const __detail::_List_node_base * | __first,
|  | const __detail::_List_node_base * | __last ) const
| inlineinherited

Definition at line 959 of file stl_list.h.

## ◆ _M_erase()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::_M_erase | ( | iterator | __position | ) |
| inlineprotectednoexcept

Definition at line 2480 of file stl_list.h.

## ◆ _M_fill_assign()

template<typename _Tp, typename _Alloc>

void list::_M_fill_assign | ( | size_type | __n,
|  | const value_type & | __val )
| protected

Definition at line 288 of file list.tcc.

## ◆ _M_fill_initialize()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::_M_fill_initialize | ( | size_type | __n,
|  | const value_type & | __x )
| inlineprotected

Definition at line 2410 of file stl_list.h.

## ◆ _M_get_node()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

_Node_alloc_traits::pointer std::_List_base< _Tp, _Alloc >::_M_get_node | ( |  | ) |
| inlineprotected

Definition at line 813 of file stl_list.h.

## ◆ _M_get_Node_allocator() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const _Node_alloc_type & std::_List_base< _Tp, _Alloc >::_M_get_Node_allocator | ( |  | ) | const
| inlineprotectednoexcept

Definition at line 866 of file stl_list.h.

## ◆ _M_get_Node_allocator() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

_Node_alloc_type & std::_List_base< _Tp, _Alloc >::_M_get_Node_allocator | ( |  | ) |
| inlineprotectednoexcept

Definition at line 862 of file stl_list.h.

## ◆ _M_get_size()

template<typename _Tp, typename _Alloc>

size_t std::_List_base< _Tp, _Alloc >::_M_get_size | ( |  | ) | const
| inlineprotectedinherited

Definition at line 797 of file stl_list.h.

## ◆ _M_inc_size()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_inc_size | ( | size_t | __n | ) |
| inlineprotectedinherited

Definition at line 801 of file stl_list.h.

## ◆ _M_init()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_init | ( |  | ) |
| inlinenoexceptinherited

Definition at line 905 of file stl_list.h.

## ◆ _M_initialize_dispatch() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator>

void std::list< _Tp, _Alloc >::_M_initialize_dispatch | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | __false_type | )
| inlineprotected

Definition at line 2390 of file stl_list.h.

## ◆ _M_initialize_dispatch() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _Integer>

void std::list< _Tp, _Alloc >::_M_initialize_dispatch | ( | _Integer | __n,
|  | _Integer | __x,
|  | __true_type | )
| inlineprotected

Definition at line 2384 of file stl_list.h.

## ◆ _M_insert()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename... _Args>

void std::list< _Tp, _Alloc >::_M_insert | ( | iterator | __position,
|  | _Args &&... | __args )
| inlineprotected

Definition at line 2470 of file stl_list.h.

## ◆ _M_move_assign() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::_M_move_assign | ( | list< _Tp, _Alloc > && | __x,
|  | false_type | )
| inlineprotected

Definition at line 2515 of file stl_list.h.

## ◆ _M_move_assign() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::_M_move_assign | ( | list< _Tp, _Alloc > && | __x,
|  | true_type | )
| inlineprotectednoexcept

Definition at line 2506 of file stl_list.h.

## ◆ _M_move_nodes()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_move_nodes | ( | _List_base< _Tp, _Alloc > && | __x | ) |
| inlineinherited

Definition at line 893 of file stl_list.h.

## ◆ _M_node_count()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_t std::list< _Tp, _Alloc >::_M_node_count | ( |  | ) | const
| inlineprotected

Definition at line 2574 of file stl_list.h.

## ◆ _M_put_node()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::_List_base< _Tp, _Alloc >::_M_put_node | ( | _Node_ptr | __p | ) |
| inlineprotectednoexcept

Definition at line 817 of file stl_list.h.

## ◆ _M_resize_pos()

template<typename _Tp, typename _Alloc>

list< _Tp, _Alloc >::const_iterator list::_M_resize_pos | ( | size_type & | __new_size | ) | const
| protected

Definition at line 170 of file list.tcc.

## ◆ _M_set_size()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_set_size | ( | size_t | __n | ) |
| inlineprotectedinherited

Definition at line 799 of file stl_list.h.

## ◆ _M_transfer()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::_M_transfer | ( | iterator | __position,
|  | iterator | __first,
|  | iterator | __last )
| inlineprotected

Definition at line 2455 of file stl_list.h.

## ◆ _S_distance() [1/2]

template<typename _Tp, typename _Alloc>

size_t std::_List_base< _Tp, _Alloc >::_S_distance | ( | const __detail::_List_node_base * | __first,
|  | const __detail::_List_node_base * | __last )
| inlinestaticinherited

Definition at line 938 of file stl_list.h.

## ◆ _S_distance() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_t std::list< _Tp, _Alloc >::_S_distance | ( | const_iterator | __first,
|  | const_iterator | __last )
| inlinestaticprotected

Definition at line 2570 of file stl_list.h.

## ◆ assign() [1/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

void std::list< _Tp, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Assigns a range to a list.

Parameters

  __first | An input iterator.
  __last | An input iterator.

This function fills a list with copies of the elements in the range [__first,__last).

Note that the assignment completely changes the list and that the resulting list's size is the same as the number of elements assigned.

Definition at line 1419 of file stl_list.h.

## ◆ assign() [2/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::assign | ( | initializer_list< value_type > | __l | ) |
| inline

Assigns an initializer_list to a list.

Parameters

  __l | An initializer_list of value_type.

Replace the contents of the list with copies of the elements in the initializer_list __l. This is linear in __l.size().

Definition at line 1441 of file stl_list.h.

## ◆ assign() [3/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::assign | ( | size_type | __n,
|  | const value_type & | __val )
| inline

Assigns a given value to a list.

Parameters

  __n | Number of elements to be assigned.
  __val | Value to be assigned.

This function fills a list with __n copies of the given value. Note that the assignment completely changes the list and that the resulting list's size is the same as the number of elements assigned.

Definition at line 1400 of file stl_list.h.

## ◆ back() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::list< _Tp, _Alloc >::back | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) reference to the data at the last element of the list.

Definition at line 1686 of file stl_list.h.

## ◆ back() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::list< _Tp, _Alloc >::back | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write reference to the data at the last element of the list.

Definition at line 1672 of file stl_list.h.

## ◆ begin() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::list< _Tp, _Alloc >::begin | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) iterator that points to the first element in the list. Iteration is done in ordinary element order.

Definition at line 1467 of file stl_list.h.

## ◆ begin() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::list< _Tp, _Alloc >::begin | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write iterator that points to the first element in the list. Iteration is done in ordinary element order.

Definition at line 1457 of file stl_list.h.

Referenced by std::list< _Tp, polymorphic_allocator< _Tp > >::list(), insert(), insert(), merge(), merge(), std::operator<=>(), operator=(), std::list< _Tp, polymorphic_allocator< _Tp > >::operator=(), remove(), remove_if(), std::list< _Tp, polymorphic_allocator< _Tp > >::splice(), unique(), and unique().

## ◆ cbegin()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::list< _Tp, _Alloc >::cbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the list. Iteration is done in ordinary element order.

Definition at line 1538 of file stl_list.h.

## ◆ cend()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::list< _Tp, _Alloc >::cend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the list. Iteration is done in ordinary element order.

Definition at line 1548 of file stl_list.h.

## ◆ clear()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::clear | ( |  | ) |
| inlinenoexcept

Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 2082 of file stl_list.h.

Referenced by operator=().

## ◆ crbegin()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::list< _Tp, _Alloc >::crbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the list. Iteration is done in reverse element order.

Definition at line 1558 of file stl_list.h.

## ◆ crend()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::list< _Tp, _Alloc >::crend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to one before the first element in the list. Iteration is done in reverse element order.

Definition at line 1568 of file stl_list.h.

## ◆ emplace()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

list< _Tp, _Alloc >::iterator list::emplace | ( | const_iterator | __position,
|  | _Args &&... | __args )

Constructs object in list before specified iterator.

Parameters

  __position | A const_iterator into the list.
  __args | Arguments.

Returns
  An iterator that points to the inserted data.

This function will insert an object of type T constructed with T(std::forward<Args>(args)...) before the specified location. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 84 of file list.tcc.

References _M_create_node(), and std::forward().

## ◆ emplace_back()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename... _Args>

reference std::list< _Tp, _Alloc >::emplace_back | ( | _Args &&... | __args | ) |
| inline

Definition at line 1817 of file stl_list.h.

## ◆ emplace_front()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename... _Args>

reference std::list< _Tp, _Alloc >::emplace_front | ( | _Args &&... | __args | ) |
| inline

Definition at line 1720 of file stl_list.h.

## ◆ empty()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

bool std::list< _Tp, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardnoexcept

Returns true if the list is empty. (Thus begin() would equal end().)

Definition at line 1578 of file stl_list.h.

Referenced by insert(), and std::list< _Tp, polymorphic_allocator< _Tp > >::splice().

## ◆ end() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::list< _Tp, _Alloc >::end | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) iterator that points one past the last element in the list. Iteration is done in ordinary element order.

Definition at line 1487 of file stl_list.h.

## ◆ end() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::list< _Tp, _Alloc >::end | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write iterator that points one past the last element in the list. Iteration is done in ordinary element order.

Definition at line 1477 of file stl_list.h.

Referenced by std::list< _Tp, polymorphic_allocator< _Tp > >::list(), merge(), merge(), std::operator<=>(), operator=(), std::list< _Tp, polymorphic_allocator< _Tp > >::operator=(), and std::list< _Tp, polymorphic_allocator< _Tp > >::splice().

## ◆ erase() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::list< _Tp, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last )
| inlinenoexcept

Remove a range of elements.

Parameters

  __first | Iterator pointing to the first element to be erased.
  __last | Iterator pointing to one past the last element to be erased.

Returns
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the list accordingly.

This operation is linear time in the size of the range and only invalidates iterators/references to the element being removed. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 2040 of file stl_list.h.

## ◆ erase() [2/2]

template<typename _Tp, typename _Alloc>

list< _Tp, _Alloc >::iterator list::erase | ( | const_iterator | __position | ) |
| noexcept

Remove element at given position.

Parameters

  __position | Iterator pointing to element to be erased.

Returns
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the list by one.

Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 145 of file list.tcc.

References list(), and erase().

Referenced by erase(), resize(), and resize().

## ◆ front() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::list< _Tp, _Alloc >::front | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) reference to the data at the first element of the list.

Definition at line 1660 of file stl_list.h.

## ◆ front() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::list< _Tp, _Alloc >::front | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write reference to the data at the first element of the list.

Definition at line 1648 of file stl_list.h.

## ◆ get_allocator()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

allocator_type std::list< _Tp, _Alloc >::get_allocator | ( |  | ) | const
| inlinenoexcept

Get a copy of the memory allocation object.

Definition at line 1447 of file stl_list.h.

Referenced by insert(), insert(), remove(), remove_if(), unique(), and unique().

## ◆ insert() [1/5]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::list< _Tp, _Alloc >::insert | ( | const_iterator | __p,
|  | initializer_list< value_type > | __l )
| inline

Inserts the contents of an initializer_list into list before specified const_iterator.

Parameters

  __p | A const_iterator into the list.
  __l | An initializer_list of value_type.

Returns
  An iterator pointing to the first element inserted (or __p).

This function will insert copies of the data in the initializer_list __l into the list before the location specified by __p.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

Definition at line 1905 of file stl_list.h.

## ◆ insert() [2/5]

template<typename _Tp, typename _Alloc>
template<typename _InputIterator, typename>

list< _Tp, _Alloc >::iterator list::insert | ( | const_iterator | __position,
|  | _InputIterator | __first,
|  | _InputIterator | __last )

Inserts a range into the list.

Parameters

  __position | An iterator into the list.
  __first | An input iterator.
  __last | An input iterator.

Returns
  Since C++11, an iterator pointing to the first element inserted (or __position). In C++98 this returns void.

This function will insert copies of the data in the range [__first,__last) into the list before the location specified by __position.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

Definition at line 128 of file list.tcc.

References list(), begin(), empty(), get_allocator(), and splice().

## ◆ insert() [3/5]

template<typename _Tp, typename _Alloc>

list< _Tp, _Alloc >::iterator list::insert | ( | const_iterator | __position,
|  | const value_type & | __x )

Inserts given value into list before specified iterator.

Parameters

  __position | An iterator into the list.
  __x | Data to be inserted.

Returns
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 96 of file list.tcc.

References list(), _M_create_node(), and insert().

Referenced by insert(), and resize().

## ◆ insert() [4/5]

template<typename _Tp, typename _Alloc>

list< _Tp, _Alloc >::iterator list::insert | ( | const_iterator | __position,
|  | size_type | __n,
|  | const value_type & | __x )

Inserts a number of copies of given data into the list.

Parameters

  __position | An iterator into the list.
  __n | Number of elements to be inserted.
  __x | Data to be inserted.

Returns
  Since C++11, an iterator pointing to the first element inserted (or __position). In C++98 this returns void.

This function will insert a specified number of copies of the given data before the location specified by __position.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

Definition at line 112 of file list.tcc.

References list(), begin(), get_allocator(), and splice().

## ◆ insert() [5/5]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::list< _Tp, _Alloc >::insert | ( | const_iterator | __position,
|  | value_type && | __x )
| inline

Inserts given value into list before specified iterator.

Parameters

  __position | An iterator into the list.
  __x | Data to be inserted.

Returns
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 1880 of file stl_list.h.

## ◆ max_size()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::list< _Tp, _Alloc >::max_size | ( |  | ) | const
| inlinenodiscardnoexcept

Returns the size() of the largest possible list.

Definition at line 1598 of file stl_list.h.

## ◆ merge() [1/4]

template<typename _Tp, typename _Alloc>

void list::merge | ( | list< _Tp, _Alloc > && | __x | ) |

Merge sorted lists.

Parameters

  __x | Sorted list to merge.

Assumes that both __x and this list are sorted according to operator<(). Merges elements of __x into this list in sorted order, leaving __x empty when complete. Elements in this list precede elements in __x that are equal.

Definition at line 397 of file list.tcc.

References list(), std::__addressof(), std::begin(), begin(), std::end(), end(), and merge().

Referenced by merge(), and merge().

## ◆ merge() [2/4]

template<typename _Tp, typename _Alloc>
template<typename _StrictWeakOrdering>

void list::merge | ( | list< _Tp, _Alloc > && | __x,
|  | _StrictWeakOrdering | __comp )

Merge sorted lists according to comparison function.

Template Parameters

  _StrictWeakOrdering | Comparison function defining sort order.

Parameters

  __x | Sorted list to merge.
  __comp | Comparison functor.

Assumes that both __x and this list are sorted according to StrictWeakOrdering. Merges elements of __x into this list in sorted order, leaving __x empty when complete. Elements in this list precede elements in __x that are equivalent according to StrictWeakOrdering().

Definition at line 437 of file list.tcc.

References list(), std::__addressof(), std::begin(), begin(), std::end(), end(), and merge().

## ◆ merge() [3/4]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::merge | ( | list< _Tp, _Alloc > & | __x | ) |
| inline

Definition at line 2312 of file stl_list.h.

## ◆ merge() [4/4]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _StrictWeakOrdering>

void std::list< _Tp, _Alloc >::merge | ( | list< _Tp, _Alloc > & | __x,
|  | _StrictWeakOrdering | __comp )
| inline

Definition at line 2339 of file stl_list.h.

## ◆ operator=() [1/3]

template<typename _Tp, typename _Alloc>

list< _Tp, _Alloc > & list::operator= | ( | const list< _Tp, _Alloc > & | __x | ) |

List assignment operator.

Parameters

  __x | A list of identical element and allocator types.

All the elements of __x are copied.

Whether the allocator is copied depends on the allocator traits.

Definition at line 262 of file list.tcc.

References list(), std::__addressof(), begin(), clear(), and end().

## ◆ operator=() [2/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

list & std::list< _Tp, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |
| inline

List initializer list assignment operator.

Parameters

  __l | An initializer_list of value_type.

Replace the contents of the list with copies of the elements in the initializer_list __l. This is linear in l.size().

Definition at line 1356 of file stl_list.h.

## ◆ operator=() [3/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

list & std::list< _Tp, _Alloc >::operator= | ( | list< _Tp, _Alloc > && | __x | ) |
| inlinenoexcept

List move assignment operator.

Parameters

  __x | A list of identical element and allocator types.

The contents of __x are moved into this list (without copying).

Afterwards __x is a valid, but unspecified list

Whether the allocator is moved depends on the allocator traits.

Definition at line 1318 of file stl_list.h.

## ◆ pop_back()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::pop_back | ( |  | ) |
| inlinenoexcept

Removes last element.

This is a typical stack operation. It shrinks the list by one. Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Definition at line 1838 of file stl_list.h.

## ◆ pop_front()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::pop_front | ( |  | ) |
| inlinenoexcept

Removes first element.

This is a typical stack operation. It shrinks the list by one. Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Definition at line 1786 of file stl_list.h.

## ◆ push_back() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::push_back | ( | const value_type & | __x | ) |
| inline

Add data to the end of the list.

Parameters

  __x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the list and assigns the given data to it. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 1803 of file stl_list.h.

## ◆ push_back() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::push_back | ( | value_type && | __x | ) |
| inline

Definition at line 1808 of file stl_list.h.

## ◆ push_front() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::push_front | ( | const value_type & | __x | ) |
| inline

Add data to the front of the list.

Parameters

  __x | Data to be added.

This is a typical stack operation. The function creates an element at the front of the list and assigns the given data to it. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 1706 of file stl_list.h.

## ◆ push_front() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::push_front | ( | value_type && | __x | ) |
| inline

Definition at line 1711 of file stl_list.h.

## ◆ rbegin() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::list< _Tp, _Alloc >::rbegin | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the list. Iteration is done in reverse element order.

Definition at line 1507 of file stl_list.h.

## ◆ rbegin() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::list< _Tp, _Alloc >::rbegin | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write reverse iterator that points to the last element in the list. Iteration is done in reverse element order.

Definition at line 1497 of file stl_list.h.

## ◆ remove()

template<typename _Tp, typename _Alloc>

list< _Tp, _Alloc >::__remove_return_type list::remove | ( | const _Tp & | __value | ) |

Remove all elements equal to value.

Parameters

  __value | The value to remove.

Removes every element in the list equal to value. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 326 of file list.tcc.

References list(), std::begin(), begin(), std::end(), get_allocator(), size(), and splice().

## ◆ remove_if()

template<typename _Tp, typename _Alloc>
template<typename _Predicate>

list< _Tp, _Alloc >::__remove_return_type list::remove_if | ( | _Predicate | __pred | ) |

Remove all elements satisfying a predicate.

Template Parameters

  _Predicate | Unary predicate function or object.

Removes every element in the list for which the predicate returns true. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 540 of file list.tcc.

References list(), std::begin(), begin(), std::end(), get_allocator(), size(), and splice().

## ◆ rend() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::list< _Tp, _Alloc >::rend | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) reverse iterator that points to one before the first element in the list. Iteration is done in reverse element order.

Definition at line 1527 of file stl_list.h.

## ◆ rend() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::list< _Tp, _Alloc >::rend | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write reverse iterator that points to one before the first element in the list. Iteration is done in reverse element order.

Definition at line 1517 of file stl_list.h.

## ◆ resize() [1/2]

template<typename _Tp, typename _Alloc>

void list::resize | ( | size_type | __new_size | ) |

Resizes the list to the specified number of elements.

Parameters

  __new_size | Number of elements the list should contain.

This function will resize the list to the specified number of elements. If the number is smaller than the list's current size the list is truncated, otherwise default constructed elements are appended.

Definition at line 225 of file list.tcc.

References std::end(), and erase().

## ◆ resize() [2/2]

template<typename _Tp, typename _Alloc>

void list::resize | ( | size_type | __new_size,
|  | const value_type & | __x )

Resizes the list to the specified number of elements.

Parameters

  __new_size | Number of elements the list should contain.
  __x | Data with which new elements should be populated.

This function will resize the list to the specified number of elements. If the number is smaller than the list's current size the list is truncated, otherwise the list is extended and new elements are populated with given data.

Definition at line 237 of file list.tcc.

References std::end(), erase(), and insert().

## ◆ reverse()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::reverse | ( |  | ) |
| inlinenoexcept

Reverse the elements in list.

Reverse the order of elements in the list in linear time.

Definition at line 2353 of file stl_list.h.

## ◆ size()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::list< _Tp, _Alloc >::size | ( |  | ) | const
| inlinenodiscardnoexcept

Returns the number of elements in the list.

Definition at line 1586 of file stl_list.h.

Referenced by std::operator<=>(), remove(), remove_if(), unique(), and unique().

## ◆ sort() [1/2]

template<typename _Tp, typename _Alloc>

void list::sort | ( |  | ) |

Sort the elements.

Sorts the elements of this list in NlogN time. Equivalent elements remain in list order.

Definition at line 476 of file list.tcc.

References std::begin(), std::empty(), and std::end().

## ◆ sort() [2/2]

template<typename _Tp, typename _Alloc>
template<typename _StrictWeakOrdering>

void list::sort | ( | _StrictWeakOrdering | __comp | ) |

Sort the elements according to comparison function.

Sorts the elements of this list in NlogN time. Equivalent elements remain in list order.

Definition at line 611 of file list.tcc.

References std::begin(), std::empty(), and std::end().

## ◆ splice() [1/6]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::splice | ( | const_iterator | __position,
|  | list< _Tp, _Alloc > && | __x )
| inlinenoexcept

Insert contents of another list.

Parameters

  __position | Iterator referencing the element to insert before.
  __x | Source list.

The elements of __x are inserted in constant time in front of the element referenced by __position. __x becomes an empty list.

Requires this != __x.

Definition at line 2102 of file stl_list.h.

Referenced by insert(), insert(), remove(), remove_if(), unique(), and unique().

## ◆ splice() [2/6]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::splice | ( | const_iterator | __position,
|  | list< _Tp, _Alloc > && | __x,
|  | const_iterator | __first,
|  | const_iterator | __last )
| inlinenoexcept

Insert range from another list.

Parameters

  __position | Iterator referencing the element to insert before.
  __x | Source list.
  __first | Iterator referencing the start of range in x.
  __last | Iterator referencing the end of range in x.

Removes elements in the range [__first,__last) and inserts them before __position in constant time.

Undefined if __position is in [__first,__last).

Definition at line 2180 of file stl_list.h.

## ◆ splice() [3/6]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::splice | ( | const_iterator | __position,
|  | list< _Tp, _Alloc > && | __x,
|  | const_iterator | __i )
| inlinenoexcept

Insert element from another list.

Parameters

  __position | Iterator referencing the element to insert before.
  __x | Source list.
  __i | Iterator referencing the element to move.

Removes the element in list __x referenced by __i and inserts it into the current list before __position.

Definition at line 2138 of file stl_list.h.

## ◆ splice() [4/6]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::splice | ( | const_iterator | __position,
|  | list< _Tp, _Alloc > & | __x )
| inlinenoexcept

Definition at line 2121 of file stl_list.h.

## ◆ splice() [5/6]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::splice | ( | const_iterator | __position,
|  | list< _Tp, _Alloc > & | __x,
|  | const_iterator | __first,
|  | const_iterator | __last )
| inlinenoexcept

Insert range from another list.

Parameters

  __position | Const_iterator referencing the element to insert before.
  __x | Source list.
  __first | Const_iterator referencing the start of range in x.
  __last | Const_iterator referencing the end of range in x.

Removes elements in the range [__first,__last) and inserts them before __position in constant time.

Undefined if __position is in [__first,__last).

Definition at line 2220 of file stl_list.h.

## ◆ splice() [6/6]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::splice | ( | const_iterator | __position,
|  | list< _Tp, _Alloc > & | __x,
|  | const_iterator | __i )
| inlinenoexcept

Insert element from another list.

Parameters

  __position | Iterator referencing the element to insert before.
  __x | Source list.
  __i | Iterator referencing the element to move.

Removes the element in list __x referenced by __i and inserts it into the current list before __position.

Definition at line 2161 of file stl_list.h.

## ◆ swap()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::list< _Tp, _Alloc >::swap | ( | list< _Tp, _Alloc > & | __x | ) |
| inlinenoexcept

Swaps data with another list.

Parameters

  __x | A list of the same element and allocator types.

This exchanges the elements between two lists in constant time. Note that the global std::swap() function is specialized such that std::swap(l1,l2) will feed to this function.

Whether the allocators are swapped depends on the allocator traits.

Definition at line 2062 of file stl_list.h.

## ◆ unique() [1/2]

template<typename _Tp, typename _Alloc>

list< _Tp, _Alloc >::__remove_return_type list::unique | ( |  | ) |

Remove consecutive duplicate elements.

For each consecutive set of elements with the same value, remove all but the first one. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 362 of file list.tcc.

References list(), std::begin(), begin(), std::end(), get_allocator(), size(), and splice().

## ◆ unique() [2/2]

template<typename _Tp, typename _Alloc>
template<typename _BinaryPredicate>

list< _Tp, _Alloc >::__remove_return_type list::unique | ( | _BinaryPredicate | __binary_pred | ) |

Remove consecutive elements satisfying a predicate.

Template Parameters

  _BinaryPredicate | Binary predicate function or object.

For each consecutive set of elements [first,last) that satisfy predicate(first,i) where i is an iterator in [first,last), remove all but the first one. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 573 of file list.tcc.

References list(), std::begin(), begin(), std::end(), get_allocator(), size(), and splice().

## Member Data Documentation

## ◆ _M_impl

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

_List_impl std::_List_base< _Tp, _Alloc >::_M_impl
| protected

Definition at line 794 of file stl_list.h.

The documentation for this class was generated from the following files:

- stl_list.h
- list.tcc